/*********************************************************************************/
/********** THIS FILE IS GENERATED BY TOUCHGFX DESIGNER, DO NOT MODIFY ***********/
/*********************************************************************************/
#include <gui_generated/graph_screen/GraphViewBase.hpp>
#include <touchgfx/Color.hpp>
#include "BitmapDatabase.hpp"

GraphViewBase::GraphViewBase() :
    buttonCallback(this, &GraphViewBase::buttonCallbackHandler)
{
    graphArea.setPosition(0, 0, 480, 198);

    graphBackground.setPosition(0, 0, 480, 198);
    graphBackground.setColor(touchgfx::Color::getColorFrom24BitRGB(255, 255, 255));
    graphArea.add(graphBackground);

    backgroundBottom.setXY(0, 198);
    backgroundBottom.setBitmap(Bitmap(BITMAP_GRAPH_BACKGROUND_BOTTOM_ID));

    newButton.setXY(75, 207);
    newButton.setBitmaps(Bitmap(BITMAP_NEW_GRAPH_ID), Bitmap(BITMAP_NEW_GRAPH_PRESSED_ID));
    newButton.setAction(buttonCallback);

    graphOrPieButton.setXY(10, 207);
    graphOrPieButton.setBitmaps(Bitmap(BITMAP_GRAPH_TOGGLE_BUTTON_ACTIVE_ID), Bitmap(BITMAP_GRAPH_TOGGLE_BUTTON_INACTIVE_ID));
    graphOrPieButton.setAction(buttonCallback);

    donutOrPieButton.setXY(195, 207);
    donutOrPieButton.setBitmaps(Bitmap(BITMAP_HALF_CIRCLE_TOGGLE_BUTTON_ACTIVE_ID), Bitmap(BITMAP_HALF_CIRCLE_TOGGLE_BUTTON_INACTIVE_ID));
    donutOrPieButton.setAction(buttonCallback);

    topMenuContainer.setPosition(0, -75, 480, 75);

    topMenuBackground.setPosition(0, 0, 480, 75);
    topMenuBackground.setColor(touchgfx::Color::getColorFrom24BitRGB(220, 224, 227));
    topMenuContainer.add(topMenuBackground);

    primaryGraphLineSetting.setXY(44, 10);
    primaryGraphLineSetting.setBitmaps(Bitmap(BITMAP_BLUE_LINE_BUTTON_INACTIVE_ID), Bitmap(BITMAP_BLUE_LINE_BUTTON_ACTIVE_ID));
    primaryGraphLineSetting.setAction(buttonCallback);
    topMenuContainer.add(primaryGraphLineSetting);

    primaryGraphDotSetting.setXY(110, 10);
    primaryGraphDotSetting.setBitmaps(Bitmap(BITMAP_BLUE_DOTS_BUTTON_INACTIVE_ID), Bitmap(BITMAP_BLUE_DOTS_BUTTON_ACTIVE_ID));
    primaryGraphDotSetting.setAction(buttonCallback);
    topMenuContainer.add(primaryGraphDotSetting);

    primaryGraphAreaSetting.setXY(176, 10);
    primaryGraphAreaSetting.setBitmaps(Bitmap(BITMAP_BLUE_AREA_BUTTON_INACTIVE_ID), Bitmap(BITMAP_BLUE_AREA_BUTTON_ACTIVE_ID));
    primaryGraphAreaSetting.setAction(buttonCallback);
    topMenuContainer.add(primaryGraphAreaSetting);

    secondaryGraphLineSetting.setXY(242, 10);
    secondaryGraphLineSetting.setBitmaps(Bitmap(BITMAP_GREEN_LINE_BUTTON_INACTIVE_ID), Bitmap(BITMAP_GREEN_LINE_BUTTON_ACTIVE_ID));
    secondaryGraphLineSetting.setAction(buttonCallback);
    topMenuContainer.add(secondaryGraphLineSetting);

    secondaryGraphDotSetting.setXY(307, 10);
    secondaryGraphDotSetting.setBitmaps(Bitmap(BITMAP_GREEN_DOTS_BUTTON_INACTIVE_ID), Bitmap(BITMAP_GREEN_DOTS_BUTTON_ACTIVE_ID));
    secondaryGraphDotSetting.setAction(buttonCallback);
    topMenuContainer.add(secondaryGraphDotSetting);

    secondaryGraphAreaSetting.setXY(374, 10);
    secondaryGraphAreaSetting.setBitmaps(Bitmap(BITMAP_GREEN_AREA_BUTTON_INACTIVE_ID), Bitmap(BITMAP_GREEN_AREA_BUTTON_ACTIVE_ID));
    secondaryGraphAreaSetting.setAction(buttonCallback);
    topMenuContainer.add(secondaryGraphAreaSetting);

    gotoMenu.setXY(404, 199);
    gotoMenu.setBitmaps(Bitmap(BITMAP_GRAPH_MENU_BUTTON_ID), Bitmap(BITMAP_GRAPH_MENU_BUTTON_PRESSED_ID));
    gotoMenu.setAction(buttonCallback);

    mcuLoad.setXY(364, 10);

    add(graphArea);
    add(backgroundBottom);
    add(newButton);
    add(graphOrPieButton);
    add(donutOrPieButton);
    add(topMenuContainer);
    add(gotoMenu);
    add(mcuLoad);
}

void GraphViewBase::setupScreen()
{
    mcuLoad.initialize();
}

void GraphViewBase::buttonCallbackHandler(const touchgfx::AbstractButton& src)
{
    if (&src == &newButton)
    {
        //NewButtonPressed
        //When newButton clicked call virtual function
        //Call newButtonPressed
        newButtonPressed();
    }
    else if (&src == &graphOrPieButton)
    {
        //GraphOrPieButtonPressed
        //When graphOrPieButton clicked call virtual function
        //Call graphOrPieButtonPressed
        graphOrPieButtonPressed();
    }
    else if (&src == &donutOrPieButton)
    {
        //DonutOrPieButtonPressed
        //When donutOrPieButton clicked call virtual function
        //Call donutOrPieButtonPressed
        donutOrPieButtonPressed();
    }
    else if (&src == &primaryGraphLineSetting)
    {
        //primaryGraphLineSettingClicked
        //When primaryGraphLineSetting clicked call virtual function
        //Call updateGraphSettings
        updateGraphSettings();
    }
    else if (&src == &primaryGraphDotSetting)
    {
        //primaryGraphDotSettingClicked
        //When primaryGraphDotSetting clicked execute C++ code
        //Execute C++ code
        updateGraphSettings();
    }
    else if (&src == &primaryGraphAreaSetting)
    {
        //primaryGraphAreaSettingClicked
        //When primaryGraphAreaSetting clicked execute C++ code
        //Execute C++ code
        updateGraphSettings();
    }
    else if (&src == &secondaryGraphLineSetting)
    {
        //secondaryGraplLineSettingClicked
        //When secondaryGraphLineSetting clicked execute C++ code
        //Execute C++ code
        updateGraphSettings();
    }
    else if (&src == &secondaryGraphDotSetting)
    {
        //secondaryGraphDotSettingClicked
        //When secondaryGraphDotSetting clicked execute C++ code
        //Execute C++ code
        updateGraphSettings();
    }
    else if (&src == &secondaryGraphAreaSetting)
    {
        //secondaryGraphAreaSettingClicked
        //When secondaryGraphAreaSetting clicked execute C++ code
        //Execute C++ code
        updateGraphSettings();
    }
    else if (&src == &gotoMenu)
    {
        //gotoMenuClicked
        //When gotoMenu clicked change screen to MainMenu
        //Go to MainMenu with screen transition towards North
        application().gotoMainMenuScreenSlideTransitionNorth();
    }
}
